require 'twitter_ebooks'

# Information about a particular Twitter user we know
class UserInfo
  attr_reader :username

  # @return [Integer] how many times we can pester this user unprompted
  attr_accessor :pesters_left

  # @param username [String]
  def initialize(username)
    @username = username
    @pesters_left = 1
  end
end

class CloneBot < Ebooks::Bot
  attr_accessor :original, :model, :model_path

  def configure
    # Configuration for all CloneBots
    self.consumer_key = "epuzZSiW2lCH0GyIojlGCYi4c"
    self.consumer_secret = "Wpz8w9mdISk9z89vPsgjBrbfc2oSfweYN2KnVFxyVnavdF7iCV"
    self.blacklist = []
    self.delay_range = 1..44
    @userinfo = {}
  end

  def top100; @top100 ||= model.keywords.take(100); end
  def top20;  @top20  ||= model.keywords.take(20); end

  def on_startup
    load_model!
    posted = tweet(model.make_statement)
    puts posted
    print posted
    scheduler.every '88m' do
      #Post a single tweet every 88 minutes
      tweet(model.make_statement)
    end
  end

  def on_message(dm)
    delay do
      reply(dm, model.make_response(dm.text))
    end
  end

  def on_mention(tweet)
    # Become more inclined to pester a user when they talk to us
    userinfo(tweet.user.screen_name).pesters_left += 1

    delay do
      reply(tweet, model.make_response(meta(tweet).mentionless, meta(tweet).limit))
    end
  end

  def on_timeline(tweet)
    return if tweet.retweeted_status?
    return unless can_pester?(tweet.user.screen_name)

    tokens = Ebooks::NLP.tokenize(tweet.text)

    interesting = tokens.find { |t| top100.include?(t.downcase) }
    very_interesting = tokens.find_all { |t| top20.include?(t.downcase) }.length > 2

    delay do
      if very_interesting
        favorite(tweet) if rand < 0.5
        retweet(tweet) if rand < 0.1
        if rand < 0.01
          userinfo(tweet.user.screen_name).pesters_left -= 1
          reply(tweet, model.make_response(meta(tweet).mentionless, meta(tweet).limit))
        end
      elsif interesting
        favorite(tweet) if rand < 0.05
        if rand < 0.001
          userinfo(tweet.user.screen_name).pesters_left -= 1
          reply(tweet, model.make_response(meta(tweet).mentionless, meta(tweet).limit))
        end
      end
    end
  end

  # Find information we've collected about a user
  # @param username [String]
  # @return [Ebooks::UserInfo]
  def userinfo(username)
    @userinfo[username] ||= UserInfo.new(username)
  end

  # Check if we're allowed to send unprompted tweets to a user
  # @param username [String]
  # @return [Boolean]
  def can_pester?(username)
    userinfo(username).pesters_left > 0
  end

  # Only follow our original user or people who are following our original user
  # @param user [Twitter::User]
  def can_follow?(username)
    @original.nil? || username == @original || twitter.friendship?(username, @original)
  end

  def favorite(tweet)
    if can_follow?(tweet.user.screen_name)
      super(tweet)
    else
      log "Unfollowing @#{tweet.user.screen_name}"
      twitter.unfollow(tweet.user.screen_name)
    end
  end

  def on_follow(user)
    if can_follow?(user.screen_name)
      follow(user.screen_name)
    else
      log "Not following @#{user.screen_name}"
    end
  end

  private
  def load_model!
    return if @model

    @model_path ||= "model/#{original}.model"

    log "Loading model #{model_path}"
    @model = Ebooks::Model.load(model_path)
  end
end

CloneBot.new("cach_ebooks") do |bot|
  bot.access_token = "3420366657-ciGf7vKjRCQBBYQFfMDUZeA0TN6gCYxfpkhpsEt"
  bot.access_token_secret = "M27qcKAMgE2Q0jy3fQdrTw6wHfVtjMJPs5K0MRmEyhT2T"

  bot.original = "cach_ebooks"
end


















=begin
require 'twitter_ebooks'

# This is an example bot definition with event handlers commented out
# You can define and instantiate as many bots as you like

class MyBot < Ebooks::Bot
  # Configuration here applies to all MyBots
  def configure
    # Consumer details come from registering an app at https://dev.twitter.com/
    # Once you have consumer details, use "ebooks auth" for new access tokens
    self.consumer_key = 'epuzZSiW2lCH0GyIojlGCYi4c' # Your app consumer key
    self.consumer_secret = 'Wpz8w9mdISk9z89vPsgjBrbfc2oSfweYN2KnVFxyVnavdF7iCV' # Your app consumer secret

    # Users to block instead of interacting with
    self.blacklist = []

    # Range in seconds to randomize delay when bot.delay is called
    self.delay_range = 1..6
  end

  def on_startup
    scheduler.every '1m' do
      # Tweet something every 24 hours
      # See https://github.com/jmettraux/rufus-scheduler
      tweet(model.make_statement)
      # pictweet("hi", "cuteselfie.jpg")
    end
  end

  def on_message(dm)
    # Reply to a DM
    reply(dm, "WHO IS BOBBY FOREMAN?")
  end

  def on_follow(user)
    # Follow a user back
    follow(user.screen_name)
  end

  def on_mention(tweet)
    # Reply to a mention
    reply(tweet, "Silence.")
  end

  def on_timeline(tweet)
    # Reply to a tweet in the bot's timeline
    reply(tweet, "she's never coming back")
  end

  def on_favorite(user, tweet)
    # Follow user who just favorited bot's tweet
    follow(user.screen_name)
  end
end

# Make a MyBot and attach it to an account
MyBot.new("cach_ebooks") do |bot|
  bot.access_token = "3420366657-ciGf7vKjRCQBBYQFfMDUZeA0TN6gCYxfpkhpsEt" # Token connecting the app to this account
  bot.access_token_secret = "M27qcKAMgE2Q0jy3fQdrTw6wHfVtjMJPs5K0MRmEyhT2T" # Secret connecting the app to this account
end
=end